﻿using System;

namespace YSoft.Rqa.VisualProwess.AutoCalibration.Db.Entities.Base
{
    public class DistortionVector
    {
        public double k1 { get; set; }
        public double k2 { get; set; }
        public double p1 { get; set; }
        public double p2 { get; set; }
        public double k3 { get; set; }
        public double k4 { get; set; }
        public double k5 { get; set; }
        public double k6 { get; set; }
        public double s1 { get; set; }
        public double s2 { get; set; }
        public double s3 { get; set; }
        public double s4 { get; set; }

        public DistortionVector(double[] vector)
        {
            if (vector.Length != 12) throw new IndexOutOfRangeException("Distortion vector must contain 12 coefficients");
            k1 = vector[0];
            k2 = vector[1];
            p1 = vector[2];
            p2 = vector[3];
            k3 = vector[4];
            k4 = vector[5];
            k5 = vector[6];
            k6 = vector[7];
            s1 = vector[8];
            s2 = vector[9];
            s3 = vector[10];
            s4 = vector[11];
        }

        public DistortionVector()
        {
            
        }
    }
}