﻿using OpenCvSharp;
using FSLibrary;
using System.Linq;
using System;

namespace YSoft.Rqa.VisualProwess.AutoCalibration.DetectionRefine
{
    internal class Sigmoid
    {
        private int[] X { get; set; }
        private double[] Y { get; set; }
        private double[] Params { get; set; }
        internal Point2f InflexPoint { get; set; }

        internal Sigmoid(int[] x, double[] y, double[] prms, Point2f inflexPoint)
        {
            X = x;
            Y = y;
            Params = prms;
            InflexPoint = inflexPoint;
        }

        internal double GetRmse()
        {
            var x = X.Select(i => (double) i).ToArray();
            var sigmoidY = LevenbergMarquardt.sigmoidCs(Params, x);
            var mse = sigmoidY
                          .Zip(Y, (a, b) => (a - b) * (a - b))
                          .Sum()
                      / Y.Length;
            return Math.Pow(mse, 0.5);
        }

    }
}