﻿using System;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using OpenCvSharp;
using YSoft.Rqa.VisualProwess.AutoCalibration.Db;
using Excel = Microsoft.Office.Interop.Excel;

namespace YSoft.Rqa.VisualProwess.AutoCalibration.DiplomkaTests
{
    public static class IntrinsicTester
    {

        public static void GetIntrinsicExcel(List<double[]> distort, List<double[,]> intrins)
        {
            var table = GetDataTable(distort, intrins);
            var lines = new List<string>();

            string[] columnNames = table.Columns.Cast<DataColumn>().
                Select(column => column.ColumnName).
                ToArray();

            var header = string.Join(",", columnNames);
            lines.Add(header);

            var valueLines = table.AsEnumerable()
                .Select(row => string.Join(",", row.ItemArray));
            lines.AddRange(valueLines);

            File.WriteAllLines(@"..\..\..\"+Path.GetRandomFileName() + ".csv", lines);

        }

        public static System.Data.DataTable GetDataTable(List<double[]> distort, List<double[,]> intrins)
        {
            System.Data.DataTable table = new System.Data.DataTable();
            table.Columns.Add("images", typeof(double));
            table.Columns.Add("detected", typeof(double));
            table.Columns.Add("cx", typeof(double));
            table.Columns.Add("cy", typeof(double));
            table.Columns.Add("fx", typeof(double));
            table.Columns.Add("fy", typeof(double));
            table.Columns.Add("d1", typeof(double));
            table.Columns.Add("d2", typeof(double));
            table.Columns.Add("d3", typeof(double));
            table.Columns.Add("d4", typeof(double));
            table.Columns.Add("d5", typeof(double));
            
            for (int i = 0; i < distort.Count; i++)
            {
                var row = new double[] {distort[i].Length, distort[i].Length, intrins[i][0, 2], intrins[i][1, 2], intrins[i][0, 0], intrins[i][1,1]};
                row = row.Concat(distort[i].ToArray()).ToArray();
                var dataRow = table.NewRow();
                for (int j = 0; j < table.Columns.Count; j++)
                {
                    dataRow[j] = row[j];
                }
                table.Rows.Add(dataRow);
            }
            return table;
        }
    }
}