﻿using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using ImageProcessing.DistributedAlgorithms.MarkerGenerating;
using OpenCvSharp;
using YSoft.Rqa.VisualProwess.AutoCalibration.MarkerDetecting;

namespace YSoft.Rqa.VisualProwess.AutoCalibration.DiplomkaTests
{
    public class MarkerDetectTester
    {
        public static void Test(List<Mat> imgs, MarkerTemplate markerTemplate)
        {
            int detected = 0;
            int truePositive = 0;
            int falsePositive = 0;
            int corrupted = 0;
            int robotFault = 0;
            int nondetected = 0;
            int tma = 0;
            int notMe = 0;
            int misDetect = 0;
            int other = 0;
            int iter = 0;
            foreach (var img in imgs)
            {
                Console.WriteLine(iter++);
                try
                {
                    var detector = new MarkerDetector(markerTemplate, img);
                    var marker = detector.Detect(false);
                    detected++;
                    for (int i = 0; i < 4; i++)
                    {
                        Cv2.DrawContours(img, new List<List<Point>> { marker.CornerShapes[i].Contour.AllPoints }, 0,
                            new Scalar(0, 255, 0), 1);
                        for (int j = 0; j < 5; j++)
                        {
                            Cv2.Circle(img, (Point)marker.CornerShapes[i].AllPoints[j], 5, Scalar.Red);
                        }
                    }
                    //Cv2.ImShow("detected marker", img);
                    //var c = Cv2.WaitKey(0);
                    //switch (c)
                    //{
                    //    case 116:
                    //        truePositive++;
                    //        break;
                    //    case 102:
                    //        falsePositive++;
                    //        break;
                    //    case 99:
                    //        corrupted++;
                    //        break;
                    //    case 114:
                    //        robotFault++;
                    //        break;
                    //}
                    if(iter == 431)
                        Cv2.ImWrite("robotFault.png", img);
                }
                catch
                {
                    //Cv2.ImShow("nondetected img", img);
                    //var c = Cv2.WaitKey(0);
                    //switch (c)
                    //{
                    //    case 116:
                    //        tma++;
                    //        break;
                    //    case 110:
                    //        notMe++;
                    //        break;
                    //    case 109:
                    //        misDetect++;
                    //        break;
                    //    case 111:
                    //        other++;
                    //        break;
                    //}
                    nondetected++;
                }
            }
        }
    }
}