﻿//using System;
//using System.Collections.Generic;
//using System.Linq;
//using OpenCvSharp;
//using YSoft.Rqa.VisualProwess.AutoCalibration.Db;
//using YSoft.Rqa.VisualProwess.AutoCalibration.Db.Entities.Base;
//using Point = OpenCvSharp.Point;
//using Size = OpenCvSharp.Size;

//namespace YSoft.Rqa.VisualProwess.AutoCalibration.RobotCalibration
//{
//    internal class Camera
//    {
//        public int Id { get; set; }
//        public double[,] IntrinsicMatrix { get; set; }
//        public double[] DistortionCoefficients { get; set; }

//        internal static Camera GetById(int id)
//        {
//            using (var db = new CalibrationContext())
//            {
//                var cam = db.Cameras
//                    .Find(id);
//                if (cam == null)
//                    throw new ArgumentOutOfRangeException($"There is no camera with Id = {id}.");
//                return MapToModel(cam);
//            }
//        }

//        internal static Camera MapToModel(YSoft.Rqa.VisualProwess.AutoCalibration.Db.Entities.Camera camera)
//        {
//            var k = new double[3, 3];
//            camera.K.ForEach(e => k[e.X, e.Y] = e.Value);
//            var distortion = new double[]
//            {
//                camera.Distortion.k1,
//                camera.Distortion.k2,
//                camera.Distortion.p1,
//                camera.Distortion.p2,
//                camera.Distortion.k3,
//                //camera.Distortion.k4,
//                //camera.Distortion.k5,
//                //camera.Distortion.k6,
//                //camera.Distortion.s1,
//                //camera.Distortion.s2,
//                //camera.Distortion.s3,
//                //camera.Distortion.s4
//            };

//            var cam = new Camera
//            {
//                Id = camera.Id,
//                IntrinsicMatrix = k,
//                DistortionCoefficients = distortion
//            };
//            return cam;
//        }

//        public static double[,] GetIntrinsicParameters(List<Mat> inputImages, List<Point3f> chessboardModel, Size patternSize, out double[] distortion, bool manualControl)
//        {
//            var modelPoints = new List<List<Point3f>>();
//            var imgPoints = new List<List<Point2f>>();
//            var i = 0;
//            foreach(var img in inputImages)
//            {
//                var isFound = Cv2.FindChessboardCorners(img, patternSize, out var corners);
//                Console.Write(i+": "+isFound);
//                i++;
//                if (!isFound)
//                {
//                    Console.WriteLine("");
//                    continue;
//                }
//                var subCorners = Cv2.CornerSubPix(img.CvtColor(ColorConversionCodes.RGB2GRAY, 1), corners,
//                        new Size(11, 11), new Size(-1, -1),
//                        new TermCriteria(CriteriaType.Eps | CriteriaType.MaxIter, 500, 1e-6))
//                    .ToList();
                
//                if (manualControl)
//                {
//                    var img2Draw = img.Clone();
//                    foreach (Point point in subCorners)
//                    {
//                        Cv2.Circle(img2Draw, point, 3, new Scalar(10, 200, 50));
//                        Cv2.ImShow("subCorners", img2Draw);
//                        Cv2.WaitKey(0);
//                    }

//                    Cv2.ImWrite(@"C:\Users\adamek\Code\ysoft\improc\src\AutoCalibration\AutoCalibration\shots\manControl\" + Guid.NewGuid() + ".bmp", img2Draw);

//                    var key = Cv2.WaitKey(0);

//                    if (key == 13)
//                    {
//                        imgPoints.Add(subCorners);
//                        modelPoints.Add(chessboardModel);
//                        Console.WriteLine(" : Confirmed");
//                    }
//                    else Console.WriteLine(" : Not Confirmed");
//                }
//                else
//                {
//                    imgPoints.Add(subCorners);
//                    modelPoints.Add(chessboardModel);
//                    Console.WriteLine("");
//                }
//            }
//            Console.WriteLine("_____________");
//            Console.WriteLine("number of Confirmed: " + imgPoints.Count);
//            var intrinsic = new double[3,3];
//            distortion = new double[5];
//            Cv2.CalibrateCamera(modelPoints, imgPoints, inputImages[0].Size(), intrinsic,
//                distortion, out var rvec, out var tvec);
//            return intrinsic;
//        }

//        internal Mat UndistortImage(Mat imageIn)
//        {
//            if(imageIn == null) throw new ArgumentNullException("Input image cannot be null");
//            var imageOut = new Mat(imageIn.Size(), imageIn.Type());
//            var newCamMat = Cv2.GetOptimalNewCameraMatrix(IntrinsicMatrix, DistortionCoefficients, imageIn.Size(), 0,
//                imageIn.Size(), out _);
//            var intr = new Mat(3, 3, MatType.CV_64F, IntrinsicMatrix);
//            var dist = new Mat(DistortionCoefficients.Length, 1, MatType.CV_64F, DistortionCoefficients);
//            var newMat = new Mat(3, 3, MatType.CV_64F, newCamMat);
//            Cv2.Undistort(imageIn, imageOut, intr, dist, newMat);
//            return imageOut;
//        }

//        internal static void AddToDb(double[,] intrinsic, double[] distortion)
//        {
//            using (var db = new CalibrationContext())
//            {
//                db.Cameras.Add(new Db.Entities.Camera
//                {
//                    Distortion = new DistortionVector(distortion),
//                    K = new List<MatrixElement>
//                        {
//                            new MatrixElement {X = 0, Y = 0, Value = intrinsic[0, 0]},
//                            new MatrixElement {X = 0, Y = 1, Value = intrinsic[0, 1]},
//                            new MatrixElement {X = 0, Y = 2, Value = intrinsic[0, 2]},
//                            new MatrixElement {X = 1, Y = 0, Value = intrinsic[1, 0]},
//                            new MatrixElement {X = 1, Y = 1, Value = intrinsic[1, 1]},
//                            new MatrixElement {X = 1, Y = 2, Value = intrinsic[1, 2]},
//                            new MatrixElement {X = 2, Y = 0, Value = intrinsic[2, 0]},
//                            new MatrixElement {X = 2, Y = 1, Value = intrinsic[2, 1]},
//                            new MatrixElement {X = 2, Y = 2, Value = intrinsic[2, 2]}
//                        }
//                });
//                db.SaveChanges();
//            }
//        }
//    }
//}