clc, clear all, close all;

%%
run('imgReading.m')

%% features
markerPoints = detectSURFFeatures(marker);
imgPoints = detectSURFFeatures(img);

% plotting
figure
imshow(marker),hold on
plot(markerPoints)

figure
imshow(img),hold on
plot(selectStrongest(imgPoints,20))

%extracting features
[markerFeatures,markerPoints] = extractFeatures(marker,markerPoints);
[imgFeatures,imgPoints] = extractFeatures(img,imgPoints);


%% matching features
matchedPairs = matchFeatures(markerFeatures,imgFeatures);

matchedMarkerPoints = markerPoints(matchedPairs(:,1),:);
matchedImgPoints = imgPoints(matchedPairs(:,2),:);

figure;
showMatchedFeatures(marker, img, matchedMarkerPoints, ...
    matchedImgPoints, 'montage');

%% get rid of outliers
[tform, inlierMarkerPoints, inlierImgPoints] = ...
    estimateGeometricTransform(matchedMarkerPoints, matchedImgPoints, 'affine');

showMatchedFeatures(marker,img,inlierMarkerPoints,inlierImgPoints,'montage');

















