clc

sizeMm = 30;
offsetMm = 3;
gimpCoef = 11.811;
% gimpCoef = 10;
borderPxl = 2;

if mod(floor(sizeMm*gimpCoef),2) == 1
    sizePxl = floor(sizeMm*gimpCoef);
else
    sizePxl = ceil(sizeMm*gimpCoef);
end
offsetPxl = round(offsetMm*gimpCoef);
halfSize = floor(sizePxl/2);

shape = logical(true(sizePxl));
shape(1:halfSize,1:halfSize) = fliplr(triu(true(halfSize)));
shape(end-halfSize+1:end,1:halfSize) = tril(true(halfSize));
shape(1:halfSize,end-halfSize+1:end) = triu(true(halfSize));
% marker(end-halfSize+1:end,end-halfSize+1:end) = fliplr(tril(true(halfSize)));
shape(halfSize+1,:) = false;
shape(:,halfSize+1) = false;

marker = logical(true(sizePxl+offsetPxl*2));
marker(offsetPxl+1:end-offsetPxl,offsetPxl+1:end-offsetPxl) = shape;
marker(:,1:borderPxl) = false;
marker(1:borderPxl,:) = false;
marker(:,end-borderPxl+1:end) = false;
marker(end-borderPxl+1:end,:) = false;
marker(offsetPxl*2+halfSize+1-borderPxl:end,offsetPxl*2+halfSize+1-borderPxl:end) = false;
marker(offsetPxl*2+halfSize+1:end,offsetPxl*2+halfSize+1:end) = true;

if 0
    imshow(marker)
    imwrite(marker,'marker5.png');
end
%% frame
scnSz = [114,177];
frameSzPxl = round(scnSz*gimpCoef+sizeMm*gimpCoef+4*offsetMm*gimpCoef);
frame = true(frameSzPxl);

frame(1:size(marker,1),1:size(marker,1)) = marker;
frame(end-size(marker,1)+1:end,1:size(marker,1)) = rot90(marker);
frame(end-size(marker,1)+1:end,end-size(marker,1)+1:end) = rot90(rot90(marker));
frame(1:size(marker,1),end-size(marker,1)+1:end) = rot90(rot90(rot90(marker)));

imshow(frame)
imwrite(frame,'frame5.png');