function J = GetJacobian(params,K,X)
%UNTITLED4 Summary of this function goes here
%   Detailed explanation goes here

tx = params(1);
ty = params(2);
tz = params(3);
t = [tx;ty;tz];
% a = deg2rad(params(4));
% b = deg2rad(params(5));
% c = deg2rad(params(6));
a = (params(4));
b = (params(5));
c = (params(6));
n = size(X,2);

Rz = [cos(c) -sin(c) 0;
      sin(c) cos(c) 0;
      0 0 1];
Ry = [cos(b) 0 sin(b);
      0 1 0;
      -sin(b) 0 cos(b)];
Rx = [1 0 0;
      0 cos(a) -sin(a);
      0 sin(a) cos(a)];
  
R = Rz*Ry*Rx;

dRz = [-sin(c) -cos(c) 0;
       cos(c) -sin(c) 0;
       0 0 0];
dRy = [-sin(b) 0 cos(b);
       0 0 0;
       -cos(b) 0 -sin(b)];
dRx = [0 0 0;
       0 -sin(a) -cos(a);
       0 cos(a) -sin(a)];

xys = K*[R t]*X;
x = xys(1,:);
y = xys(2,:);
s = xys(3,:);
%actually df/d_anything
dtx = K*[1 0 0]';
dty = K*[0 1 0]';
dtz = K*[0 0 1]';

da = K*Rz*Ry*dRx*X(1:3,:);
db = K*Rz*dRy*Rx*X(1:3,:);
dc = K*dRz*Ry*Rx*X(1:3,:);

%actually d(f/s)/d_anything
df_dtx = [dtx(1).*s - x.*dtx(3);
          dtx(2).*s - y.*dtx(3)]./repmat(s.^2,[2,1]);

df_dty = [dty(1).*s - x.*dty(3);
          dty(2).*s - y.*dty(3)]./repmat(s.^2,[2,1]);
      
df_dtz = [dtz(1).*s - x.*dtz(3);
          dtz(2).*s - y.*dtz(3)]./repmat(s.^2,[2,1]);
      
df_da = [da(1,:).*s - x.*da(3,:);
         da(2,:).*s - y.*da(3,:)]./repmat(s.^2,[2,1]);
      
df_db = [db(1,:).*s - x.*db(3,:);
         db(2,:).*s - y.*db(3,:)]./repmat(s.^2,[2,1]);
      
df_dc = [dc(1,:).*s - x.*dc(3,:);
         dc(2,:).*s - y.*dc(3,:)]./repmat(s.^2,[2,1]);    
      
%it is possible to devide J by ./repmat(s.^2,[2,1]) instead of every df_...
%you just need to reshape it and repmat it again
J = [reshape(df_dtx,[2*n,1])...
     reshape(df_dty,[2*n,1])...
     reshape(df_dtz,[2*n,1])...
     reshape(df_da,[2*n,1])...
     reshape(df_db,[2*n,1])...
     reshape(df_dc,[2*n,1])
     ];



end

