clear all;
% close all;

%% init of cameras
%basler
if ~exist('g')
    g = gigecam;
end
g.PixelFormat = 'BayerRG8';

%webcam
c = webcam(2);
preview(c)
waitforbuttonpress
%get images
imgG = snapshot(g);
imgC = snapshot(c);
[imgG,imgC] = resizeImg(imgG,imgC);

%% detection
pointsG = markerDetect(imgG);
pointsC = markerDetect(imgC);


%% reconstruction
stereoParams = open('stereoParams.mat');
stereoParams = stereoParams.stereoParams;
P1 = cameraMatrix(stereoParams.CameraParameters1,eye(3),zeros(3,1))';
P2 = cameraMatrix(stereoParams.CameraParameters2,stereoParams.RotationOfCamera2,stereoParams.TranslationOfCamera2)';

x3D = LinearTriang(pointsG,pointsC,P1,P2)
x3D = HomogCoord(x3D,'3D');
