clc;clear all;close all;
img  = imread('img\m8.jpg');
imshow(img);

%% filtrace cervene

colorOffset = 25;
productConst = 2;
expConst = 150;
for i=1:size(img,1)
    for j=1:size(img,2)
        if img(i,j,1) < max(img(i,j,2),img(i,j,3))*(exp(-double(img(i,j,1))/expConst)+1) || abs(img(i,j,2)-img(i,j,3)) > colorOffset
            img(i,j,:) = 0;
        end
%         if img(i,j,1) < (img(i,j,2)+img(i,j,3))*productConst || abs(img(i,j,2)-img(i,j,3)) > colorOffset
%             img(i,j,:) = 0;
%         end
    end
end
figure
%imshow(img)

%% canny

edges = edge(rgb2gray(img),'canny');
imshow(edges)

%% radon

theta = 0:179;
[R,xp] = radon(edges,theta);

figure
imagesc(theta, xp, R); colormap(hot);
xlabel('\theta (degrees)');
ylabel('x^{\prime} (pixels from center)');
title('R_{\theta} (x^{\prime})');
colorbar

%maxima

[~,pos1] = max(R(:))
[pos1(1) pos1(2)] = ind2sub(size(R),pos1)


eraseOffset = 20;
for a = -eraseOffset:eraseOffset
    for b = -eraseOffset:eraseOffset
        R(pos1(1)+a, pos1(2)+b) = 0;
    end
end
pos1(1) = xp(pos1(1))

[~,pos2] = max(R(:));
[pos2(1) pos2(2)] = ind2sub(size(R),pos2);
pos2(1) = xp(pos2(1));

%ind2sub to prevedou na souradnice od 1, ale ja mam stupne od 0 do 179 ->
%musim odecist jednicku
pos1(2) = pos1(2) - 1;


%% vypocet primky
%bod
centre = [size(img,1)/2 size(img,2)/2];%[y,x]
xoffset = pos1(1)*cosd(360-pos1(2));
yoffset = pos1(1)*sind(360-pos1(2));
A = [centre(1)+yoffset, centre(2)+xoffset];

figure
imshow(edges)
hold on
plot(centre(2),centre(1), 'gx', 'MarkerSize',5,'LineWidth',3)
plot([A(2) centre(2)],[A(1) centre(1)],'Color','r','LineWidth', 3)

% smernice
k = (centre(1)-A(1))/(centre(2)-A(2));
q = A(1)-k*A(2);
x = 1:20:1920;
y = 1:20:1080;
% plot(x,k*x+q,'g*');
% plot((y-q)/k,y,'g*');

%kolmice
kp = -k^-1;
qp = A(1)-kp*A(2);
plot(x,kp*x+qp,'bx');
plot((y-qp)/kp,y,'bx');

hold off




