close all, clc;

%% magyar constants
brightnessCoef = 0.2;   %coef for treshold
edgeRatio = 0.01;    %ratio of edges vs non-edges
edgeCoef = 1.5;      % coef for multiplication treshold of LoG

%% reading img
img = imread('imgCovered.bmp','bmp');
figure,imshow(img,[])

%% treshold
maxBrightness = max(max(img));
imgTH = img.*uint8(img>maxBrightness*brightnessCoef);
figure,imshow(imgTH,[])

%% edge by LoG
%from origin
[imgLoG,tresh] = edge(img,'log');
while sum(sum(imgLoG))/(1920*1200) > edgeRatio
    [imgLoG,tresh] = edge(img,'log',tresh*edgeCoef);
end
figure,imshow(imgLoG,[])
%from tresholded img
[imgTHLoG,tresh] = edge(imgTH,'log');
while sum(sum(imgTHLoG))/(1920*1200) > edgeRatio
    [imgTHLoG,tresh] = edge(imgTH,'log',tresh*edgeCoef);
end
figure,imshow(imgTHLoG,[])

%% radon
theta = 0:179;
[R,xp] = radon(imgTHLoG,theta);
figure, imshow(R,[],'Xdata',theta,'Ydata',xp,'InitialMagnification','fit')
xlabel('\theta (degrees)')
ylabel('x''')
colormap(gca,hot), colorbar

%% 

bw = imbinarize(img,'global');
imgERODE = imerode(bw,strel('disk',4,0));
figure,imshow(imgERODE,[])
imgCLOSED = imclose(imgERODE, strel('square',10));
figure,imshow(bw,[]);
figure,imshow(imgCLOSED,[]);